您的位置:首页 > 其它

HDU - 4028 The time of a day(离散+DP)

2014-11-05 23:08 447 查看
Description

There are no days and nights on byte island, so the residents here can hardly determine the length of a single day. Fortunately, they have invented a clock with several pointers. They have N pointers which can move round the clock.
Every pointer ticks once per second, and the i-th pointer move to the starting position after i times of ticks. The wise of the byte island decide to define a day as the time interval between the initial time and the first time when all the pointers moves
to the position exactly the same as the initial time.

The wise of the island decide to choose some of the N pointers to make the length of the day greater or equal to M. They want to know how many different ways there are to make it possible.



Input

There are a lot of test cases. The first line of input contains exactly one integer, indicating the number of test cases.

For each test cases, there are only one line contains two integers N and M, indicating the number of pointers and the lower bound for seconds of a day M. (1 <= N <= 40, 1 <= M <= 2 63-1)



Output

For each test case, output a single integer denoting the number of ways.


Sample Input

3
5 5
10 1
10 128




Sample Output

Case #1: 22
Case #2: 1023
Case #3: 586


题意:给出1-n的数字,问有多少的子集的lcm是大于等于m的

思路:m很大,子集也有2^40,但是发现最小公倍数的范围只有4万多个,所以可以用dp[i][j]表示前i个数最小公倍数是j的方案数,离散处理最小公倍数的结果节省空间

#include <iostream>
#include <cstdio>
#include <cstring>
#include <map>
#include <algorithm>
//typedef long long ll;
typedef __int64 ll;
using namespace std;

map<ll, ll> dp[50];

ll gcd(ll a, ll b) {
	return (b == 0) ? a : gcd(b, a%b);
}

ll lcm(ll a, ll b) {
	return a / gcd(a, b) * b;
}

void init() {
	dp[1][1] = 1;
	map<ll, ll>::iterator it;
	for (int i = 2; i <= 40; i++) {
		dp[i] = dp[i-1];
		dp[i][i]++;
		for (it = dp[i-1].begin(); it != dp[i-1].end(); it++)
			dp[i][lcm(i, it->first)] += it->second;
	}
}

int main() {
	init();
	int t, cas = 1;
	scanf("%d", &t);
	int n;
	ll m;
	while (t--) {
		scanf("%d%I64d", &n, &m);
		ll ans = 0;
		map<ll, ll>::iterator it;
		for (it = dp
.begin(); it != dp
.end(); it++)
			if (it->first >= m)
				ans += it->second;
		printf("Case #%d: %I64d\n", cas++, ans);
	}
	return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: